ACdream 1216(二路单调递增子序列)

题目链接:http://acdream.info/problem?pid=1216

Beautiful People

Special Judge Time Limit: 10000/5000MS (Java/Others) Memory Limit: 128000/64000KB (Java/Others)
Problem Description

      The most prestigious sports club in one city has exactly N members. Each of its members is strong and beautiful. More precisely, i-th member of this club (members being numbered by the time they entered the club) has strength Si and beauty Bi. Since this is a very prestigious club, its members are very rich and therefore extraordinary people, so they often extremely hate each other. Strictly speaking, i-th member of the club Mr X hates j-th member of the club Mr Y if Si <= Sj and Bi >= Bj or if Si >= Sj and Bi <= Bj (if both properties of Mr X are greater then corresponding properties of Mr Y, he doesn't even notice him, on the other hand, if both of his properties are less, he respects Mr Y very much).

      To celebrate a new 2003 year, the administration of the club is planning to organize a party. However they are afraid that if two people who hate each other would simultaneouly attend the party, after a drink or two they would start a fight. So no two people who hate each other should be invited. On the other hand, to keep the club prestige at the apropriate level, administration wants to invite as many people as possible.

      Being the only one among administration who is not afraid of touching a computer, you are to write a program which would find out whom to invite to the party.

Input
      The first line of the input file contains integer N — the number of members of the club. ( 2 ≤ N ≤ 100 000). Next N lines contain two numbers each — S i and B respectively ( 1 ≤ Si, Bi ≤ 109).
Output
      On the first line of the output file print the maximum number of the people that can be invited to the party. On the second line output N integers — numbers of members to be invited in arbitrary order. If several solutions exist, output any one.
Sample Input
4
1 1
1 2
2 1
2 2
Sample Output
2
1 4
思路:将这n个人的第一关键字从小到大排序,如果第一关键字相等就让第二关键字从大到小排序(这里想想就能明白),排好之后就相当于在第二关键字序列中找一个最长的单调上升子序列~~~

用O(n*n)算法会TLE,

考虑另外一种O(n*logn)的算法即可~即二分优化

附上代码:

#include <iostream>
#include <stdio.h>
#include <string.h>
#include <string>
#include <cstdio>
#include <cmath>
#include <algorithm>
const int INF=99999999;
const int N=1e5+1000;
using namespace std;

struct node
{
 int si,bi;
 int id;
}a[N];

bool cmp(node a,node b)
{
  if(a.si!=b.si)
    return  a.si<b.si;
  return a.bi>b.bi;
}
int dp[N],mark[N],len;

int find(int i) //二分求下界~
{
    int left,right,mid;
    left=0,right=len;
    while(left<right)
    {
        mid = left+(right-left)/2;
        if(dp[mid]>=a[i].bi) right=mid;
        else left=mid+1;
    }
    return left;
}


int main()
{
  int n;
  while(scanf("%d",&n)!=EOF)
  {
    for(int i=1;i<=n;i++)
    {
      scanf("%d%d",&a[i].si,&a[i].bi);
      a[i].id=i;
    }
    sort(a+1,a+1+n,cmp);

    len=1;
    dp[1]=a[1].bi;
    mark[1]=1;

    for(int i=2;i<=n;i++)
    {
     if(a[i].bi>dp[len])
        {
            dp[++len]=a[i].bi;
            mark[i]=len;
        }
     else
        {
          int pos=find(i);
              dp[pos]=a[i].bi;
              mark[i]=pos;
        }
    }

   printf("%d\n",len);
   for(int i=n;i>=1;i--)
   {
     if(mark[i]==len)
     {
       if(len==1)
       printf("%d\n",a[i].id);
       else
        printf("%d ",a[i].id);
       len--;
     }
   }
  }
  return 0;
}


评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值